(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('ad-angle-layout', ['exports', '@angular/common', '@angular/core', '@angular/router'], factory) :
    (factory((global['ad-angle-layout'] = {}),global.ng.common,global.ng.core,global.ng.router));
}(this, (function (exports,common,i0,router) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SettingsService = /** @class */ (function () {
        function SettingsService() {
            // User Settings
            // -----------------------------------
            this.user = {
                name: 'John',
                job: 'ng-developer',
                picture: 'assets/img/user/02.jpg'
            };
            // App Settings
            // -----------------------------------
            this.app = {
                name: 'Angle',
                description: 'Angular Bootstrap Admin Template',
                year: ((new Date()).getFullYear())
            };
            // Layout Settings
            // -----------------------------------
            this.layout = {
                isFixed: true,
                isCollapsed: false,
                isBoxed: false,
                isRTL: false,
                horizontal: false,
                isFloat: false,
                asideHover: false,
                theme: null,
                asideScrollbar: false,
                isCollapsedText: false,
                useFullLayout: false,
                hiddenFooter: false,
                offsidebarOpen: false,
                asideToggled: false,
                viewAnimation: 'ng-fadeInUp'
            };
        }
        /**
         * @param {?} name
         * @return {?}
         */
        SettingsService.prototype.getAppSetting = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                return name ? this.app[name] : this.app;
            };
        /**
         * @param {?} name
         * @return {?}
         */
        SettingsService.prototype.getUserSetting = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                return name ? this.user[name] : this.user;
            };
        /**
         * @param {?} name
         * @return {?}
         */
        SettingsService.prototype.getLayoutSetting = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                return name ? this.layout[name] : this.layout;
            };
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        SettingsService.prototype.setAppSetting = /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
            function (name, value) {
                if (typeof this.app[name] !== 'undefined') {
                    this.app[name] = value;
                }
            };
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        SettingsService.prototype.setUserSetting = /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
            function (name, value) {
                if (typeof this.user[name] !== 'undefined') {
                    this.user[name] = value;
                }
            };
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        SettingsService.prototype.setLayoutSetting = /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
            function (name, value) {
                if (typeof this.layout[name] !== 'undefined') {
                    return this.layout[name] = value;
                }
            };
        /**
         * @param {?} name
         * @return {?}
         */
        SettingsService.prototype.toggleLayoutSetting = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                return this.setLayoutSetting(name, !this.getLayoutSetting(name));
            };
        SettingsService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        SettingsService.ctorParameters = function () { return []; };
        /** @nocollapse */ SettingsService.ngInjectableDef = i0.defineInjectable({ factory: function SettingsService_Factory() { return new SettingsService(); }, token: SettingsService, providedIn: "root" });
        return SettingsService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LayoutComponent = /** @class */ (function () {
        function LayoutComponent(settings) {
            this.settings = settings;
        }
        Object.defineProperty(LayoutComponent.prototype, "isFixed", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('isFixed'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "isCollapsed", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('isCollapsed'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "isBoxed", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('isBoxed'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "useFullLayout", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('useFullLayout'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "hiddenFooter", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('hiddenFooter'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "horizontal", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('horizontal'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "isFloat", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('isFloat'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "offsidebarOpen", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('offsidebarOpen'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "asideToggled", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('asideToggled'); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LayoutComponent.prototype, "isCollapsedText", {
            get: /**
             * @return {?}
             */ function () { return this.settings.getLayoutSetting('isCollapsedText'); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LayoutComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                document.addEventListener('click', ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    /** @type {?} */
                    var target = ( /** @type {?} */(e.target));
                    if (target.tagName === 'A') {
                        e.preventDefault();
                    }
                }));
                // Va permettre d'activer le offsidebar qd on clic pour l'afficher
                document.getElementsByTagName('html')[0].classList.add('csstransforms3d');
            };
        LayoutComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ad-layout',
                        encapsulation: i0.ViewEncapsulation.None,
                        template: "<div class=\"wrapper\">\n  <!-- top navbar-->\n  <header class=\"topnavbar-wrapper\">\n     <!-- START Top Navbar-->\n     <nav class=\"navbar topnavbar\">\n        <!-- START navbar header-->\n        <div class=\"navbar-header\">\n           <a class=\"navbar-brand\" href=\"#/\">\n              <router-outlet name=\"menu-top-logo\"></router-outlet>\n           </a>\n        </div>\n        <!-- END navbar header-->\n        <!-- START Left navbar-->\n        <ul class=\"navbar-nav mr-auto flex-row\">\n          <router-outlet name=\"menu-top-left\"></router-outlet>\n        </ul>\n        <!-- END Left navbar-->\n        <!-- START Right Navbar-->\n        <ul class=\"navbar-nav flex-row\">\n          <router-outlet name=\"menu-top-right\"></router-outlet>\n        </ul>\n        <!-- END Right Navbar-->\n     </nav>\n     <!-- END Top Navbar-->\n  </header>\n  <!-- sidebar-->\n  <aside class=\"aside-container\">\n    <router-outlet name=\"menu-left\"></router-outlet>\n    <ad-menu-left></ad-menu-left>\n  </aside>\n  <!-- offsidebar-->\n  <aside class=\"offsidebar\">\n     <!-- START Off Sidebar (right)-->\n     <nav>\n        <router-outlet name=\"menu-right\"></router-outlet>\n     </nav>\n     <!-- END Off Sidebar (right)-->\n  </aside>\n  <!-- Main section-->\n  <section class=\"section-container\">\n     <!-- Page content-->\n     <div class=\"content-wrapper\">\n      <router-outlet></router-outlet>\n     </div>\n  </section>\n  <!-- Page footer-->\n  <footer class=\"footer-container\">\n    <router-outlet name=\"menu-bottom\"></router-outlet>\n  </footer>\n</div>\n",
                        styles: ["body{padding:0;margin:0}"]
                    }] }
        ];
        /** @nocollapse */
        LayoutComponent.ctorParameters = function () {
            return [
                { type: SettingsService }
            ];
        };
        LayoutComponent.propDecorators = {
            isFixed: [{ type: i0.HostBinding, args: ['class.layout-fixed',] }],
            isCollapsed: [{ type: i0.HostBinding, args: ['class.aside-collapsed',] }],
            isBoxed: [{ type: i0.HostBinding, args: ['class.layout-boxed',] }],
            useFullLayout: [{ type: i0.HostBinding, args: ['class.layout-fs',] }],
            hiddenFooter: [{ type: i0.HostBinding, args: ['class.hidden-footer',] }],
            horizontal: [{ type: i0.HostBinding, args: ['class.layout-h',] }],
            isFloat: [{ type: i0.HostBinding, args: ['class.aside-float',] }],
            offsidebarOpen: [{ type: i0.HostBinding, args: ['class.offsidebar-open',] }],
            asideToggled: [{ type: i0.HostBinding, args: ['class.aside-toggled',] }],
            isCollapsedText: [{ type: i0.HostBinding, args: ['class.aside-collapsed-text',] }]
        };
        return LayoutComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MenuService = /** @class */ (function () {
        function MenuService() {
            this.menuItems = [];
        }
        /**
         * @param {?} items
         * @return {?}
         */
        MenuService.prototype.addMenu = /**
         * @param {?} items
         * @return {?}
         */
            function (items) {
                var _this = this;
                items.forEach(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    _this.menuItems.push(item);
                }));
            };
        /**
         * @return {?}
         */
        MenuService.prototype.getMenu = /**
         * @return {?}
         */
            function () {
                return this.menuItems;
            };
        MenuService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        MenuService.ctorParameters = function () { return []; };
        /** @nocollapse */ MenuService.ngInjectableDef = i0.defineInjectable({ factory: function MenuService_Factory() { return new MenuService(); }, token: MenuService, providedIn: "root" });
        return MenuService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MenuLeftComponent = /** @class */ (function () {
        function MenuLeftComponent(menu, settings, injector) {
            this.menu = menu;
            this.settings = settings;
            this.injector = injector;
            this.sbclickEvent = 'click.sidebar-toggle';
            this.$doc = null;
            this.menuItems = menu.getMenu();
        }
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.router = this.injector.get(router.Router);
                this.router.events.subscribe(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) {
                    // close any submenu opened when route changes
                    _this.removeFloatingNav();
                    // scroll view to top
                    window.scrollTo(0, 0);
                    // close sidebar on route change
                    _this.settings.setLayoutSetting('asideToggled', false);
                }));
                // enable sidebar autoclose from external clicks
                this.anyClickClose();
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.anyClickClose = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.$doc = $(document).on(this.sbclickEvent, ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    if (!$(e.target).parents('.aside-container').length) {
                        _this.settings.setLayoutSetting('asideToggled', false);
                    }
                }));
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.$doc) {
                    this.$doc.off(this.sbclickEvent);
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        MenuLeftComponent.prototype.toggleSubmenuClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                event.preventDefault();
                if (!this.isSidebarCollapsed() && !this.isSidebarCollapsedText() && !this.isEnabledHover()) {
                    /** @type {?} */
                    var ul_1 = $(event.currentTarget.nextElementSibling);
                    // hide other submenus
                    /** @type {?} */
                    var parentNav_1 = ul_1.parents('.sidebar-subnav');
                    $('.sidebar-subnav').each(( /**
                     * @param {?} idx
                     * @param {?} el
                     * @return {?}
                     */function (idx, el) {
                        /** @type {?} */
                        var $el = $(el);
                        // if element is not a parent or self ul
                        if (el !== parentNav_1[0] && el !== ul_1[0]) {
                            _this.closeMenu($el);
                        }
                    }));
                    // abort if not UL to process
                    if (!ul_1.length) {
                        return;
                    }
                    // any child menu should start closed
                    ul_1.find('.sidebar-subnav').each(( /**
                     * @param {?} idx
                     * @param {?} el
                     * @return {?}
                     */function (idx, el) {
                        _this.closeMenu($(el));
                    }));
                    // toggle UL height
                    /** @type {?} */
                    var ulHeight = ul_1.css('height');
                    if (ulHeight === 'auto' || parseInt(ulHeight, 10)) {
                        this.closeMenu(ul_1);
                    }
                    else {
                        // expand menu
                        ul_1.on('transitionend', ( /**
                         * @return {?}
                         */function () {
                            ul_1.css('height', 'auto').off('transitionend');
                        })).css('height', ul_1[0].scrollHeight);
                        // add class to manage animation
                        ul_1.addClass('opening');
                    }
                }
            };
        // Close menu collapsing height
        // Close menu collapsing height
        /**
         * @param {?} elem
         * @return {?}
         */
        MenuLeftComponent.prototype.closeMenu =
            // Close menu collapsing height
            /**
             * @param {?} elem
             * @return {?}
             */
            function (elem) {
                elem.css('height', elem[0].scrollHeight); // set height
                elem.css('height', 0); // and move to zero to collapse
                elem.removeClass('opening');
            };
        /**
         * @param {?} $el
         * @return {?}
         */
        MenuLeftComponent.prototype.getPaddingTop = /**
         * @param {?} $el
         * @return {?}
         */
            function ($el) {
                /** @type {?} */
                var val = $el.css('padding-top');
                return parseInt(val ? val : 0, 0);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        MenuLeftComponent.prototype.toggleSubmenuHover = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var self = this;
                if (this.isSidebarCollapsed() || this.isSidebarCollapsedText() || this.isEnabledHover()) {
                    event.preventDefault();
                    this.removeFloatingNav();
                    /** @type {?} */
                    var ul = $(event.currentTarget.nextElementSibling);
                    /** @type {?} */
                    var anchor = $(event.currentTarget);
                    if (!ul.length) {
                        return; // if not submenu return
                    }
                    /** @type {?} */
                    var $aside = $('.aside-container');
                    /** @type {?} */
                    var $asideInner = $aside.children('.aside-inner');
                    // for top offset calculation
                    /** @type {?} */
                    var $sidebar = $asideInner.children('.sidebar');
                    /** @type {?} */
                    var mar = this.getPaddingTop($asideInner) + this.getPaddingTop($aside);
                    /** @type {?} */
                    var scrollTop = $sidebar.scrollTop();
                    if (!scrollTop) {
                        scrollTop = 0;
                    }
                    /** @type {?} */
                    var itemTop = ((anchor.parent().position().top) + mar) - scrollTop;
                    /** @type {?} */
                    var floatingNav_1 = ul.clone().appendTo($aside);
                    /** @type {?} */
                    var vwHeight = document.body.clientHeight;
                    // let itemTop = anchor.position().top || anchor.offset().top;
                    floatingNav_1
                        .removeClass('opening') // necesary for demo if switched between normal//collapsed mode
                        .addClass('nav-floating')
                        .css({
                        position: this.settings.getLayoutSetting('isFixed') ? 'fixed' : 'absolute',
                        top: itemTop,
                        bottom: (floatingNav_1.outerHeight(true) + itemTop > vwHeight) ? 0 : 'auto'
                    });
                    floatingNav_1
                        .on('mouseleave', ( /**
                 * @return {?}
                 */function () { floatingNav_1.remove(); }))
                        .find('a').on('click', ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                        e.preventDefault(); // prevents page reload on click
                        // prevents page reload on click
                        // get the exact route path to navigate
                        /** @type {?} */
                        var routeTo = $(this).attr('route');
                        if (routeTo) {
                            self.router.navigate([routeTo]);
                        }
                    }));
                    this.listenForExternalClicks();
                }
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.listenForExternalClicks = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var $doc = $(document).on('click.sidebar', ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    if (!$(e.target).parents('.aside-container').length) {
                        _this.removeFloatingNav();
                        $doc.off('click.sidebar');
                    }
                }));
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.removeFloatingNav = /**
         * @return {?}
         */
            function () {
                $('.nav-floating').remove();
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.isSidebarCollapsed = /**
         * @return {?}
         */
            function () {
                return this.settings.getLayoutSetting('isCollapsed');
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.isSidebarCollapsedText = /**
         * @return {?}
         */
            function () {
                return this.settings.getLayoutSetting('isCollapsedText');
            };
        /**
         * @return {?}
         */
        MenuLeftComponent.prototype.isEnabledHover = /**
         * @return {?}
         */
            function () {
                return this.settings.getLayoutSetting('asideHover');
            };
        MenuLeftComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ad-menu-left',
                        template: "<!-- START Sidebar (left)-->\n<div class=\"aside-inner\">\n  <nav class=\"sidebar\" sidebar-anyclick-close=\"\" [class.show-scrollbar]=\"settings.getLayoutSetting('asideScrollbar')\">\n\n      <!-- START sidebar nav-->\n      <ul class=\"sidebar-nav\">\n\n          <!-- START user info-->\n          <!--\n          <li class=\"has-user-block\">\n              <app-userblock></app-userblock>\n          </li>\n          -->\n          <!-- END user info-->\n\n          <li *ngFor='let item of menuItems' [ngClass]=\"{'nav-heading': item.heading}\" [routerLinkActive]=\"['active']\">\n              <!-- menu heading -->\n              <span *ngIf=\"item.heading\">{{item.text}}</span>\n              <!-- external links -->\n              <a href *ngIf=\"!item.heading && !item.submenu && item.elink\" [attr.target]=\"item.target\" [attr.href]=\"item.elink\" title=\"{{item.text}}\">\n                  <span class=\"float-right\" *ngIf=\"item.alert\" [ngClass]=\"item.label || 'badge badge-success'\">{{item.alert}}</span>\n                  <em class=\"{{item.icon}}\" *ngIf=\"item.icon\"></em>\n                  <span>{{item.text}}</span>\n              </a>\n              <!-- single menu item -->\n              <a href *ngIf=\"!item.heading && !item.submenu && !item.elink\" [routerLink]=\"item.link\" [attr.route]=\"item.link\" title=\"{{item.text}}\"\n                  (click)=\"toggleSubmenuClick($event)\" (mouseenter)=\"toggleSubmenuHover($event)\">\n                  <span class=\"float-right\" *ngIf=\"item.alert\" [ngClass]=\"item.label || 'badge badge-success'\">{{item.alert}}</span>\n                  <em class=\"{{item.icon}}\" *ngIf=\"item.icon\"></em>\n                  <span>{{item.text}}</span>\n              </a>\n              <!-- has submenu -->\n              <a href *ngIf=\"!item.heading && item.submenu\" title=\"{{item.text}}\"\n                  (click)=\"toggleSubmenuClick($event)\" (mouseenter)=\"toggleSubmenuHover($event)\">\n                      <span class=\"float-right\" *ngIf=\"item.alert\" [ngClass]=\"item.label || 'badge badge-success'\">{{item.alert}}</span>\n                      <em class=\"{{item.icon}}\" *ngIf=\"item.icon\"></em>\n                      <span>{{item.text}}</span>\n              </a>\n              <!-- SUBLEVEL -->\n              <ul *ngIf=\"item.submenu\" class=\"sidebar-nav sidebar-subnav\" [routerLinkActive]=\"['opening']\">\n                  <li class=\"sidebar-subnav-header\">{{item.text}}</li>\n                  <li *ngFor='let subitem of item.submenu' [routerLinkActive]=\"['active']\">\n                      <!-- sublevel: external links -->\n                      <a href *ngIf=\"!subitem.heading && !subitem.submenu && subitem.elink\" [attr.target]=\"subitem.target\" [attr.href]=\"subitem.elink\" title=\"{{subitem.text}}\">\n                          <span class=\"float-right\" *ngIf=\"subitem.alert\" [ngClass]=\"subitem.label || 'badge badge-success'\">{{subitem.alert}}</span>\n                          <em class=\"{{subitem.icon}}\" *ngIf=\"subitem.icon\"></em>\n                          <span>{{subitem.text}}</span>\n                      </a>\n                      <!-- sublevel: single menu item  -->\n                      <a href *ngIf=\"!subitem.submenu && !subitem.elink\" [routerLink]=\"subitem.link\" [attr.route]=\"subitem.link\" title=\"{{subitem.text}}\">\n                          <span class=\"float-right\" *ngIf=\"subitem.alert\" [ngClass]=\"subitem.label || 'badge badge-success'\">{{subitem.alert}}</span>\n                          <em class=\"{{subitem.icon}}\" *ngIf=\"subitem.icon\"></em>\n                          <span>{{subitem.text}}</span>\n                      </a>\n                      <!-- sublevel: has submenu -->\n                      <a href *ngIf=\"subitem.submenu\" title=\"{{subitem.text}}\"\n                          (click)=\"toggleSubmenuClick($event)\" (mouseenter)=\"toggleSubmenuHover($event)\">\n                              <span class=\"float-right\" *ngIf=\"subitem.alert\" [ngClass]=\"subitem.label || 'badge badge-success'\">{{subitem.alert}}</span>\n                              <em class=\"{{subitem.icon}}\" *ngIf=\"subitem.icon\"></em>\n                              <span>{{subitem.text}}</span>\n                      </a>\n                      <!-- SUBLEVEL 2 -->\n                      <ul *ngIf=\"subitem.submenu\" class=\"sidebar-nav sidebar-subnav level2\" [routerLinkActive]=\"['opening']\">\n                          <li *ngFor='let subitem2 of subitem.submenu' [routerLinkActive]=\"['active']\">\n                              <!-- sublevel 2: single menu item  -->\n                              <a href *ngIf=\"!subitem2.submenu\" [routerLink]=\"subitem2.link\" [attr.route]=\"subitem2.link\" title=\"{{subitem2.text}}\">\n                                  <span class=\"float-right\" *ngIf=\"subitem2.alert\" [ngClass]=\"subitem2.label || 'badge badge-success'\">{{subitem2.alert}}</span>\n                                  <em class=\"{{subitem2.icon}}\" *ngIf=\"subitem2.icon\"></em>\n                                  <span>{{subitem2.text}}</span>\n                              </a>\n                              <!-- sublevel2: has submenu -->\n                              <a href *ngIf=\"subitem2.submenu\" title=\"{{subitem2.text}}\"\n                                  (click)=\"toggleSubmenuClick($event)\" (mouseenter)=\"toggleSubmenuHover($event)\">\n                                      <span class=\"float-right\" *ngIf=\"subitem2.alert\" [ngClass]=\"subitem2.label || 'badge badge-success'\">{{subitem2.alert}}</span>\n                                      <em class=\"{{subitem2.icon}}\" *ngIf=\"subitem2.icon\"></em>\n                                      <span>{{subitem2.text}}</span>\n                              </a>\n                              <!-- SUBLEVEL 3 -->\n                              <ul *ngIf=\"subitem2.submenu\" class=\"sidebar-nav sidebar-subnav level3\" [routerLinkActive]=\"['opening']\">\n                                  <li *ngFor='let subitem3 of subitem2.submenu' [routerLinkActive]=\"['active']\">\n                                      <!-- sublevel 2: single menu item  -->\n                                      <a href *ngIf=\"!subitem3.submenu\" [routerLink]=\"subitem3.link\" [attr.route]=\"subitem3.link\" title=\"{{subitem3.text}}\">\n                                          <span class=\"float-right\" *ngIf=\"subitem3.alert\" [ngClass]=\"subitem3.label || 'badge badge-success'\">{{subitem3.alert}}</span>\n                                          <em class=\"{{subitem3.icon}}\" *ngIf=\"subitem3.icon\"></em>\n                                          <span>{{subitem3.text}}</span>\n                                      </a>\n                                      <!-- sublevel3: has submenu -->\n                                      <a href *ngIf=\"subitem3.submenu\" title=\"{{subitem3.text}}\"\n                                          (click)=\"toggleSubmenuClick($event)\" (mouseenter)=\"toggleSubmenuHover($event)\">\n                                              <span class=\"float-right\" *ngIf=\"subitem3.alert\" [ngClass]=\"subitem3.label || 'badge badge-success'\">{{subitem3.alert}}</span>\n                                              <em class=\"{{subitem3.icon}}\" *ngIf=\"subitem3.icon\"></em>\n                                              <span>{{subitem3.text}}</span>\n                                      </a>\n                                      <!-- SUBLEVEL 4 -->\n                                      <ul *ngIf=\"subitem3.submenu\" class=\"sidebar-nav sidebar-subnav level3\" [routerLinkActive]=\"['opening']\">\n                                          <li *ngFor='let subitem4 of subitem3.submenu' [routerLinkActive]=\"['active']\">\n                                              <!-- sublevel 2: single menu item  -->\n                                              <a href *ngIf=\"!subitem4.submenu\" [routerLink]=\"subitem4.link\" [attr.route]=\"subitem4.link\" title=\"{{subitem4.text}}\">\n                                                  <span class=\"float-right\" *ngIf=\"subitem4.alert\" [ngClass]=\"subitem4.label || 'badge badge-success'\">{{subitem4.alert}}</span>\n                                                  <em class=\"{{subitem4.icon}}\" *ngIf=\"subitem4.icon\"></em>\n                                                  <span>{{subitem4.text}}</span>\n                                              </a>\n                                          </li>\n                                      </ul>\n                                  </li>\n                              </ul>\n                          <li>\n                      </ul>\n                  <li>\n              </ul>\n          </li>\n\n      </ul>\n      <!-- END sidebar nav-->\n\n  </nav>\n</div>\n<!-- END Sidebar (left)-->\n",
                        styles: [".sidebar{height:100%;padding-bottom:20px;background-color:#fff;overflow-x:hidden;-webkit-overflow-scrolling:touch}.sidebar:after{content:\"\";background:rgba(0,0,0,.15);position:absolute;display:block;top:0;bottom:0;right:0;width:1px;-webkit-transform:translateZ(0)}.sidebar .nav-heading{padding:12px 15px;color:#919da8;font-size:13px;letter-spacing:.035em;pointer-events:none;cursor:default}.sidebar-nav{position:relative;font-size:14px;margin-bottom:0;padding-left:0;list-style:none}.sidebar-nav>.nav-heading:first-child{padding-top:20px}.sidebar-nav>li{display:block;border-left:3px solid transparent;transition:border-left-color .4s}.sidebar-nav>li>.nav-item,.sidebar-nav>li>a{position:relative;display:block;padding:12px 24px;color:#515253;letter-spacing:.025em;font-weight:400;cursor:pointer}.sidebar-nav>li>.nav-item:focus,.sidebar-nav>li>.nav-item:hover,.sidebar-nav>li>a:focus,.sidebar-nav>li>a:hover{text-decoration:none;outline:0;color:#23b7e5}.sidebar-nav>li>.nav-item>em,.sidebar-nav>li>a>em{width:1.8em;display:inline-block;font-style:normal;line-height:1;-webkit-font-smoothing:antialiased;color:inherits}.sidebar-nav>li.active,.sidebar-nav>li.active .sidebar-nav,.sidebar-nav>li.active>.nav-item,.sidebar-nav>li.active>a,.sidebar-nav>li.open,.sidebar-nav>li.open .sidebar-nav,.sidebar-nav>li.open>.nav-item,.sidebar-nav>li.open>a{background-color:#fcfcfc;color:#23b7e5}.sidebar-nav>li.active>.nav-item>em,.sidebar-nav>li.active>a>em,.sidebar-nav>li.open>.nav-item>em,.sidebar-nav>li.open>a>em{color:#23b7e5}.sidebar-nav>li.active{border-left-color:#23b7e5}.sidebar-nav .badge{display:block}@media only screen and (min-width:1025px){.sidebar:not(.show-scrollbar){margin-right:-17px;overflow-y:scroll}}.sidebar-subnav{background-color:#fff;height:0;overflow:hidden;transition:height .2s}.sidebar-subnav>.sidebar-subnav-header{color:#515253;display:none;padding:10px 20px;font-weight:700}.sidebar-subnav>li{border-left:0!important}.sidebar-subnav>li>.nav-item,.sidebar-subnav>li>a{display:block;position:relative;padding:10px 20px 10px 53px;font-weight:400;background-color:transparent!important;color:#515253}.sidebar-subnav>li>.nav-item:focus,.sidebar-subnav>li>.nav-item:hover,.sidebar-subnav>li>a:focus,.sidebar-subnav>li>a:hover{color:#23b7e5}.sidebar-subnav>li>.nav-item>em,.sidebar-subnav>li>a>em{display:inline-block;width:1.8em;margin:0 0 0 -2em}.sidebar-subnav>li.active>.nav-item,.sidebar-subnav>li.active>a{color:#23b7e5}.sidebar-subnav>li.active>.nav-item:after,.sidebar-subnav>li.active>a:after{border-color:#23b7e5;background-color:#23b7e5}.sidebar-subnav>li .sidebar-nav>li{padding-left:5px}.sidebar-subnav.nav-floating{border:1px solid rgba(0,0,0,.15);margin-left:-1px}.sidebar-subnav.nav-floating,.sidebar-subnav.nav-floating .collapse,.sidebar-subnav.nav-floating .sidebar-subnav{height:auto!important;display:block!important;visibility:visible!important}.sidebar-subnav.nav-floating .collapse.opening,.sidebar-subnav.nav-floating .sidebar-subnav.opening,.sidebar-subnav.nav-floating.opening{-webkit-animation:none!important;animation:none!important}.sidebar-subnav.nav-floating>.sidebar-subnav-header{display:block}.sidebar-subnav.nav-floating li>.nav-item,.sidebar-subnav.nav-floating li>a{padding-left:20px}.sidebar-subnav.nav-floating li>.nav-item em,.sidebar-subnav.nav-floating li>a em{margin-left:0}.aside-collapsed .sidebar,.aside-collapsed-text .sidebar{overflow-x:hidden}.aside-collapsed .sidebar>.sidebar-nav .sidebar-nav,.aside-collapsed .sidebar>.sidebar-nav>.nav-heading,.aside-collapsed .sidebar>.sidebar-nav>li>.nav-item>span,.aside-collapsed .sidebar>.sidebar-nav>li>a>span,.aside-collapsed-text .sidebar>.sidebar-nav .sidebar-nav,.aside-collapsed-text .sidebar>.sidebar-nav>.nav-heading,.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item>span,.aside-collapsed-text .sidebar>.sidebar-nav>li>a>span{display:none!important}.aside-collapsed .sidebar>.sidebar-nav>li,.aside-collapsed-text .sidebar>.sidebar-nav>li{width:69px}.aside-collapsed .sidebar>.sidebar-nav>li>.nav-item,.aside-collapsed .sidebar>.sidebar-nav>li>a,.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item,.aside-collapsed-text .sidebar>.sidebar-nav>li>a{text-indent:-3px;padding:20px 0;text-align:center}.aside-collapsed .sidebar>.sidebar-nav>li>.nav-item>em,.aside-collapsed .sidebar>.sidebar-nav>li>a>em,.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item>em,.aside-collapsed-text .sidebar>.sidebar-nav>li>a>em{font-size:1.6em;width:auto}.aside-collapsed .sidebar>.sidebar-nav>li>.nav-item:focus,.aside-collapsed .sidebar>.sidebar-nav>li>a:focus,.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item:focus,.aside-collapsed-text .sidebar>.sidebar-nav>li>a:focus{background-color:transparent}.aside-collapsed .sidebar>.sidebar-nav>li>.nav-item:focus>em,.aside-collapsed .sidebar>.sidebar-nav>li>a:focus>em,.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item:focus>em,.aside-collapsed-text .sidebar>.sidebar-nav>li>a:focus>em{color:inherit}.aside-collapsed .sidebar .sidebar-nav .badge,.aside-collapsed-text .sidebar .sidebar-nav .badge{position:absolute;top:10px;right:5px;text-indent:0}.aside-collapsed-text .sidebar>.sidebar-nav>li>.nav-item>span,.aside-collapsed-text .sidebar>.sidebar-nav>li>a>span{display:block!important;font-size:12px}.aside-collapsed-text .sidebar>.sidebar-nav>li{width:88px}.aside-collapsed-text .sidebar>.sidebar-nav>li>a{padding:14px 0}.aside-collapsed-text .sidebar>.sidebar-nav>li>a>em{font-size:1.4em}.sidebar-subnav.opening{height:auto;transition:height .2s;-webkit-animation:.5s fadeInLeft;animation:.5s fadeInLeft}"]
                    }] }
        ];
        /** @nocollapse */
        MenuLeftComponent.ctorParameters = function () {
            return [
                { type: MenuService },
                { type: SettingsService },
                { type: i0.Injector }
            ];
        };
        return MenuLeftComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LayoutModule = /** @class */ (function () {
        function LayoutModule() {
        }
        LayoutModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [LayoutComponent, MenuLeftComponent],
                        imports: [
                            common.CommonModule, router.RouterModule
                        ],
                        providers: [SettingsService, MenuService],
                        exports: [LayoutComponent]
                    },] }
        ];
        return LayoutModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.LayoutComponent = LayoutComponent;
    exports.LayoutModule = LayoutModule;
    exports.SettingsService = SettingsService;
    exports.MenuService = MenuService;
    exports.ɵa = MenuLeftComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ad-angle-layout.umd.js.map